Index: src/config.cpp
===================================================================
--- src/config.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/config.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -8,4 +8,5 @@
 #include <cstring>
 
+#include "World.hpp"
 #include "atom.hpp"
 #include "bond.hpp"
@@ -19,4 +20,5 @@
 #include "molecule.hpp"
 #include "periodentafel.hpp"
+#include "World.hpp"
 
 /******************************** Functions for class ConfigFileBuffer **********************/
@@ -73,5 +75,5 @@
   file= new ifstream(filename);
   if (file == NULL) {
-    eLog() << Verbose(1) << "config file " << filename << " missing!" << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "config file " << filename << " missing!" << endl);
     return;
   }
@@ -84,9 +86,9 @@
   file->clear();
   file->seekg(file_position, ios::beg);
-  Log() << Verbose(1) << NoLines-1 << " lines were recognized." << endl;
+  DoLog(1) && (Log() << Verbose(1) << NoLines-1 << " lines were recognized." << endl);
 
   // allocate buffer's 1st dimension
   if (buffer != NULL) {
-    eLog() << Verbose(1) << "FileBuffer->buffer is not NULL!" << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "FileBuffer->buffer is not NULL!" << endl);
     return;
   } else
@@ -104,5 +106,5 @@
     lines++;
   } while((!file->eof()) && (lines < NoLines));
-  Log() << Verbose(1) << lines-1 << " lines were read into the buffer." << endl;
+  DoLog(1) && (Log() << Verbose(1) << lines-1 << " lines were read into the buffer." << endl);
 
   // close and exit
@@ -143,5 +145,5 @@
   map<const char *, int, IonTypeCompare> IonTypeLineMap;
   if (LineMapping == NULL) {
-    eLog() << Verbose(0) << "map pointer is NULL: " << LineMapping << endl;
+    DoeLog(0) && (eLog()<< Verbose(0) << "map pointer is NULL: " << LineMapping << endl);
     performCriticalExit();
     return;
@@ -159,5 +161,5 @@
       LineMapping[CurrentLine+(nr++)] = runner->second;
     else {
-      eLog() << Verbose(0) << "config::MapIonTypesInBuffer - NoAtoms is wrong: We are past the end of the file!" << endl;
+      DoeLog(0) && (eLog()<< Verbose(0) << "config::MapIonTypesInBuffer - NoAtoms is wrong: We are past the end of the file!" << endl);
       performCriticalExit();
     }
@@ -249,5 +251,5 @@
         Thermostat = None;
       } else {
-        Log() << Verbose(1) << "Warning: " << ThermostatNames[0] << " thermostat not implemented, falling back to None." << endl;
+        DoLog(1) && (Log() << Verbose(1) << "Warning: " << ThermostatNames[0] << " thermostat not implemented, falling back to None." << endl);
         Thermostat = None;
       }
@@ -257,5 +259,5 @@
         ParseForParameter(verbose,fb,"Thermostat", 0, 2, 1, int_type, &ScaleTempStep, 1, critical); // read scaling frequency
       } else {
-        Log() << Verbose(1) << "Warning: " << ThermostatNames[0] << " thermostat not implemented, falling back to None." << endl;
+        DoLog(1) && (Log() << Verbose(1) << "Warning: " << ThermostatNames[0] << " thermostat not implemented, falling back to None." << endl);
         Thermostat = None;
       }
@@ -265,5 +267,5 @@
         ParseForParameter(verbose,fb,"Thermostat", 0, 2, 1, int_type, &ScaleTempStep, 1, critical); // read collision rate
       } else {
-        Log() << Verbose(1) << "Warning: " << ThermostatNames[0] << " thermostat not implemented, falling back to None." << endl;
+        DoLog(1) && (Log() << Verbose(1) << "Warning: " << ThermostatNames[0] << " thermostat not implemented, falling back to None." << endl);
         Thermostat = None;
       }
@@ -273,10 +275,10 @@
         ParseForParameter(verbose,fb,"Thermostat", 0, 2, 1, double_type, &TempFrequency, 1, critical); // read gamma
         if (ParseForParameter(verbose,fb,"Thermostat", 0, 3, 1, double_type, &alpha, 1, optional)) {
-          Log() << Verbose(2) << "Extended Stochastic Thermostat detected with interpolation coefficient " << alpha << "." << endl;
+          DoLog(2) && (Log() << Verbose(2) << "Extended Stochastic Thermostat detected with interpolation coefficient " << alpha << "." << endl);
         } else {
           alpha = 1.;
         }
       } else {
-        Log() << Verbose(1) << "Warning: " << ThermostatNames[0] << " thermostat not implemented, falling back to None." << endl;
+        DoLog(1) && (Log() << Verbose(1) << "Warning: " << ThermostatNames[0] << " thermostat not implemented, falling back to None." << endl);
         Thermostat = None;
       }
@@ -286,5 +288,5 @@
         ParseForParameter(verbose,fb,"Thermostat", 0, 2, 1, double_type, &TempFrequency, 1, critical); // read \tau_T
       } else {
-        Log() << Verbose(1) << "Warning: " << ThermostatNames[0] << " thermostat not implemented, falling back to None." << endl;
+        DoLog(1) && (Log() << Verbose(1) << "Warning: " << ThermostatNames[0] << " thermostat not implemented, falling back to None." << endl);
         Thermostat = None;
       }
@@ -295,14 +297,14 @@
         alpha = 0.;
       } else {
-        Log() << Verbose(1) << "Warning: " << ThermostatNames[0] << " thermostat not implemented, falling back to None." << endl;
+        DoLog(1) && (Log() << Verbose(1) << "Warning: " << ThermostatNames[0] << " thermostat not implemented, falling back to None." << endl);
         Thermostat = None;
       }
     } else {
-      Log() << Verbose(1) << " Warning: thermostat name was not understood!" << endl;
+      DoLog(1) && (Log() << Verbose(1) << " Warning: thermostat name was not understood!" << endl);
       Thermostat = None;
     }
   } else {
     if ((MaxOuterStep > 0) && (TargetTemp != 0)) 
-      Log() << Verbose(2) <<  "No thermostat chosen despite finite temperature MD, falling back to None." << endl;
+      DoLog(2) && (Log() << Verbose(2) <<  "No thermostat chosen despite finite temperature MD, falling back to None." << endl);
     Thermostat = None;
   }
@@ -320,178 +322,178 @@
 
   do {
-    Log() << Verbose(0) << "===========EDIT CONFIGURATION============================" << endl;
-    Log() << Verbose(0) << " A - mainname (prefix for all runtime files)" << endl;
-    Log() << Verbose(0) << " B - Default path (for runtime files)" << endl;
-    Log() << Verbose(0) << " C - Path of pseudopotential files" << endl;
-    Log() << Verbose(0) << " D - Number of coefficient sharing processes" << endl;
-    Log() << Verbose(0) << " E - Number of wave function sharing processes" << endl;
-    Log() << Verbose(0) << " F - 0: Don't output density for OpenDX, 1: do" << endl;
-    Log() << Verbose(0) << " G - 0: Don't output physical data, 1: do" << endl;
-    Log() << Verbose(0) << " H - 0: Don't output densities of each unperturbed orbital for OpenDX, 1: do" << endl;
-    Log() << Verbose(0) << " I - 0: Don't output current density for OpenDX, 1: do" << endl;
-    Log() << Verbose(0) << " J - 0: Don't do the full current calculation, 1: do" << endl;
-    Log() << Verbose(0) << " K - 0: Don't do perturbation calculation to obtain susceptibility and shielding, 1: do" << endl;
-    Log() << Verbose(0) << " L - 0: Wannier centres as calculated, 1: common centre for all, 2: unite centres according to spread, 3: cell centre, 4: shifted to nearest grid point" << endl;
-    Log() << Verbose(0) << " M - Absolute begin of unphysical sawtooth transfer for position operator within cell" << endl;
-    Log() << Verbose(0) << " N - (0,1,2) x,y,z-plane to do two-dimensional current vector cut" << endl;
-    Log() << Verbose(0) << " O - Absolute position along vector cut axis for cut plane" << endl;
-    Log() << Verbose(0) << " P - Additional Gram-Schmidt-Orthonormalization to stabilize numerics" << endl;
-    Log() << Verbose(0) << " Q - Initial integer value of random number generator" << endl;
-    Log() << Verbose(0) << " R - for perturbation 0, for structure optimization defines upper limit of iterations" << endl;
-    Log() << Verbose(0) << " T - Output visual after ...th step" << endl;
-    Log() << Verbose(0) << " U - Output source densities of wave functions after ...th step" << endl;
-    Log() << Verbose(0) << " X - minimization iterations per wave function, if unsure leave at default value 0" << endl;
-    Log() << Verbose(0) << " Y - tolerance value for total spread in iterative Jacobi diagonalization" << endl;
-    Log() << Verbose(0) << " Z - Maximum number of minimization iterations" << endl;
-    Log() << Verbose(0) << " a - Relative change in total energy to stop min. iteration" << endl;
-    Log() << Verbose(0) << " b - Relative change in kinetic energy to stop min. iteration" << endl;
-    Log() << Verbose(0) << " c - Check stop conditions every ..th step during min. iteration" << endl;
-    Log() << Verbose(0) << " e - Maximum number of minimization iterations during initial level" << endl;
-    Log() << Verbose(0) << " f - Relative change in total energy to stop min. iteration during initial level" << endl;
-    Log() << Verbose(0) << " g - Relative change in kinetic energy to stop min. iteration during initial level" << endl;
-    Log() << Verbose(0) << " h - Check stop conditions every ..th step during min. iteration during initial level" << endl;
+    DoLog(0) && (Log() << Verbose(0) << "===========EDIT CONFIGURATION============================" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " A - mainname (prefix for all runtime files)" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " B - Default path (for runtime files)" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " C - Path of pseudopotential files" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " D - Number of coefficient sharing processes" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " E - Number of wave function sharing processes" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " F - 0: Don't output density for OpenDX, 1: do" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " G - 0: Don't output physical data, 1: do" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " H - 0: Don't output densities of each unperturbed orbital for OpenDX, 1: do" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " I - 0: Don't output current density for OpenDX, 1: do" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " J - 0: Don't do the full current calculation, 1: do" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " K - 0: Don't do perturbation calculation to obtain susceptibility and shielding, 1: do" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " L - 0: Wannier centres as calculated, 1: common centre for all, 2: unite centres according to spread, 3: cell centre, 4: shifted to nearest grid point" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " M - Absolute begin of unphysical sawtooth transfer for position operator within cell" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " N - (0,1,2) x,y,z-plane to do two-dimensional current vector cut" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " O - Absolute position along vector cut axis for cut plane" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " P - Additional Gram-Schmidt-Orthonormalization to stabilize numerics" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " Q - Initial integer value of random number generator" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " R - for perturbation 0, for structure optimization defines upper limit of iterations" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " T - Output visual after ...th step" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " U - Output source densities of wave functions after ...th step" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " X - minimization iterations per wave function, if unsure leave at default value 0" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " Y - tolerance value for total spread in iterative Jacobi diagonalization" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " Z - Maximum number of minimization iterations" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " a - Relative change in total energy to stop min. iteration" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " b - Relative change in kinetic energy to stop min. iteration" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " c - Check stop conditions every ..th step during min. iteration" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " e - Maximum number of minimization iterations during initial level" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " f - Relative change in total energy to stop min. iteration during initial level" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " g - Relative change in kinetic energy to stop min. iteration during initial level" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " h - Check stop conditions every ..th step during min. iteration during initial level" << endl);
 //    Log() << Verbose(0) << " j - six lower diagonal entries of matrix, defining the unit cell" << endl;
-    Log() << Verbose(0) << " k - Energy cutoff of plane wave basis in Hartree" << endl;
-    Log() << Verbose(0) << " l - Maximum number of levels in multi-level-ansatz" << endl;
-    Log() << Verbose(0) << " m - Factor by which grid nodes increase between standard and upper level" << endl;
-    Log() << Verbose(0) << " n - 0: Don't use RiemannTensor, 1: Do" << endl;
-    Log() << Verbose(0) << " o - Factor by which grid nodes increase between Riemann and standard(?) level" << endl;
-    Log() << Verbose(0) << " p - Number of Riemann levels" << endl;
-    Log() << Verbose(0) << " r - 0: Don't Use RiemannTensor, 1: Do" << endl;
-    Log() << Verbose(0) << " s - 0: Doubly occupied orbitals, 1: Up-/Down-Orbitals" << endl;
-    Log() << Verbose(0) << " t - Number of orbitals (depends pn SpinType)" << endl;
-    Log() << Verbose(0) << " u - Number of SpinUp orbitals (depends on SpinType)" << endl;
-    Log() << Verbose(0) << " v - Number of SpinDown orbitals (depends on SpinType)" << endl;
-    Log() << Verbose(0) << " w - Number of additional, unoccupied orbitals" << endl;
-    Log() << Verbose(0) << " x - radial cutoff for ewald summation in Bohrradii" << endl;
-    Log() << Verbose(0) << " y - 0: Don't do structure optimization beforehand, 1: Do" << endl;
-    Log() << Verbose(0) << " z - 0: Units are in Bohr radii, 1: units are in Aengstrom" << endl;
-    Log() << Verbose(0) << " i - 0: Coordinates given in file are absolute, 1: ... are relative to unit cell" << endl;
-    Log() << Verbose(0) << "=========================================================" << endl;
-    Log() << Verbose(0) << "INPUT: ";
+    DoLog(0) && (Log() << Verbose(0) << " k - Energy cutoff of plane wave basis in Hartree" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " l - Maximum number of levels in multi-level-ansatz" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " m - Factor by which grid nodes increase between standard and upper level" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " n - 0: Don't use RiemannTensor, 1: Do" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " o - Factor by which grid nodes increase between Riemann and standard(?) level" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " p - Number of Riemann levels" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " r - 0: Don't Use RiemannTensor, 1: Do" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " s - 0: Doubly occupied orbitals, 1: Up-/Down-Orbitals" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " t - Number of orbitals (depends pn SpinType)" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " u - Number of SpinUp orbitals (depends on SpinType)" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " v - Number of SpinDown orbitals (depends on SpinType)" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " w - Number of additional, unoccupied orbitals" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " x - radial cutoff for ewald summation in Bohrradii" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " y - 0: Don't do structure optimization beforehand, 1: Do" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " z - 0: Units are in Bohr radii, 1: units are in Aengstrom" << endl);
+    DoLog(0) && (Log() << Verbose(0) << " i - 0: Coordinates given in file are absolute, 1: ... are relative to unit cell" << endl);
+    DoLog(0) && (Log() << Verbose(0) << "=========================================================" << endl);
+    DoLog(0) && (Log() << Verbose(0) << "INPUT: ");
     cin >> choice;
 
     switch (choice) {
         case 'A': // mainname
-          Log() << Verbose(0) << "Old: " << config::mainname << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::mainname << "\t new: ");
           cin >> config::mainname;
           break;
         case 'B': // defaultpath
-          Log() << Verbose(0) << "Old: " << config::defaultpath << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::defaultpath << "\t new: ");
           cin >> config::defaultpath;
           break;
         case 'C': // pseudopotpath
-          Log() << Verbose(0) << "Old: " << config::pseudopotpath << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::pseudopotpath << "\t new: ");
           cin >> config::pseudopotpath;
           break;
 
         case 'D': // ProcPEGamma
-          Log() << Verbose(0) << "Old: " << config::ProcPEGamma << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::ProcPEGamma << "\t new: ");
           cin >> config::ProcPEGamma;
           break;
         case 'E': // ProcPEPsi
-          Log() << Verbose(0) << "Old: " << config::ProcPEPsi << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::ProcPEPsi << "\t new: ");
           cin >> config::ProcPEPsi;
           break;
         case 'F': // DoOutVis
-          Log() << Verbose(0) << "Old: " << config::DoOutVis << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::DoOutVis << "\t new: ");
           cin >> config::DoOutVis;
           break;
         case 'G': // DoOutMes
-          Log() << Verbose(0) << "Old: " << config::DoOutMes << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::DoOutMes << "\t new: ");
           cin >> config::DoOutMes;
           break;
         case 'H': // DoOutOrbitals
-          Log() << Verbose(0) << "Old: " << config::DoOutOrbitals << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::DoOutOrbitals << "\t new: ");
           cin >> config::DoOutOrbitals;
           break;
         case 'I': // DoOutCurrent
-          Log() << Verbose(0) << "Old: " << config::DoOutCurrent << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::DoOutCurrent << "\t new: ");
           cin >> config::DoOutCurrent;
           break;
         case 'J': // DoFullCurrent
-          Log() << Verbose(0) << "Old: " << config::DoFullCurrent << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::DoFullCurrent << "\t new: ");
           cin >> config::DoFullCurrent;
           break;
         case 'K': // DoPerturbation
-          Log() << Verbose(0) << "Old: " << config::DoPerturbation << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::DoPerturbation << "\t new: ");
           cin >> config::DoPerturbation;
           break;
         case 'L': // CommonWannier
-          Log() << Verbose(0) << "Old: " << config::CommonWannier << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::CommonWannier << "\t new: ");
           cin >> config::CommonWannier;
           break;
         case 'M': // SawtoothStart
-          Log() << Verbose(0) << "Old: " << config::SawtoothStart << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::SawtoothStart << "\t new: ");
           cin >> config::SawtoothStart;
           break;
         case 'N': // VectorPlane
-          Log() << Verbose(0) << "Old: " << config::VectorPlane << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::VectorPlane << "\t new: ");
           cin >> config::VectorPlane;
           break;
         case 'O': // VectorCut
-          Log() << Verbose(0) << "Old: " << config::VectorCut << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::VectorCut << "\t new: ");
           cin >> config::VectorCut;
           break;
         case 'P': // UseAddGramSch
-          Log() << Verbose(0) << "Old: " << config::UseAddGramSch << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::UseAddGramSch << "\t new: ");
           cin >> config::UseAddGramSch;
           break;
         case 'Q': // Seed
-          Log() << Verbose(0) << "Old: " << config::Seed << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::Seed << "\t new: ");
           cin >> config::Seed;
           break;
 
         case 'R': // MaxOuterStep
-          Log() << Verbose(0) << "Old: " << config::MaxOuterStep << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::MaxOuterStep << "\t new: ");
           cin >> config::MaxOuterStep;
           break;
         case 'T': // OutVisStep
-          Log() << Verbose(0) << "Old: " << config::OutVisStep << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::OutVisStep << "\t new: ");
           cin >> config::OutVisStep;
           break;
         case 'U': // OutSrcStep
-          Log() << Verbose(0) << "Old: " << config::OutSrcStep << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::OutSrcStep << "\t new: ");
           cin >> config::OutSrcStep;
           break;
         case 'X': // MaxPsiStep
-          Log() << Verbose(0) << "Old: " << config::MaxPsiStep << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::MaxPsiStep << "\t new: ");
           cin >> config::MaxPsiStep;
           break;
         case 'Y': // EpsWannier
-          Log() << Verbose(0) << "Old: " << config::EpsWannier << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::EpsWannier << "\t new: ");
           cin >> config::EpsWannier;
           break;
 
         case 'Z': // MaxMinStep
-          Log() << Verbose(0) << "Old: " << config::MaxMinStep << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::MaxMinStep << "\t new: ");
           cin >> config::MaxMinStep;
           break;
         case 'a': // RelEpsTotalEnergy
-          Log() << Verbose(0) << "Old: " << config::RelEpsTotalEnergy << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::RelEpsTotalEnergy << "\t new: ");
           cin >> config::RelEpsTotalEnergy;
           break;
         case 'b': // RelEpsKineticEnergy
-          Log() << Verbose(0) << "Old: " << config::RelEpsKineticEnergy << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::RelEpsKineticEnergy << "\t new: ");
           cin >> config::RelEpsKineticEnergy;
           break;
         case 'c': // MaxMinStopStep
-          Log() << Verbose(0) << "Old: " << config::MaxMinStopStep << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::MaxMinStopStep << "\t new: ");
           cin >> config::MaxMinStopStep;
           break;
         case 'e': // MaxInitMinStep
-          Log() << Verbose(0) << "Old: " << config::MaxInitMinStep << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::MaxInitMinStep << "\t new: ");
           cin >> config::MaxInitMinStep;
           break;
         case 'f': // InitRelEpsTotalEnergy
-          Log() << Verbose(0) << "Old: " << config::InitRelEpsTotalEnergy << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::InitRelEpsTotalEnergy << "\t new: ");
           cin >> config::InitRelEpsTotalEnergy;
           break;
         case 'g': // InitRelEpsKineticEnergy
-          Log() << Verbose(0) << "Old: " << config::InitRelEpsKineticEnergy << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::InitRelEpsKineticEnergy << "\t new: ");
           cin >> config::InitRelEpsKineticEnergy;
           break;
         case 'h': // InitMaxMinStopStep
-          Log() << Verbose(0) << "Old: " << config::InitMaxMinStopStep << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::InitMaxMinStopStep << "\t new: ");
           cin >> config::InitMaxMinStopStep;
           break;
@@ -499,73 +501,74 @@
 //        case 'j': // BoxLength
 //          Log() << Verbose(0) << "enter lower triadiagonalo form of basis matrix" << endl << endl;
+//          double * const cell_size = World::getInstance().getDomain();
 //          for (int i=0;i<6;i++) {
 //            Log() << Verbose(0) << "Cell size" << i << ": ";
-//            cin >> mol->cell_size[i];
+//            cin >> cell_size[i];
 //          }
 //          break;
 
         case 'k': // ECut
-          Log() << Verbose(0) << "Old: " << config::ECut << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::ECut << "\t new: ");
           cin >> config::ECut;
           break;
         case 'l': // MaxLevel
-          Log() << Verbose(0) << "Old: " << config::MaxLevel << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::MaxLevel << "\t new: ");
           cin >> config::MaxLevel;
           break;
         case 'm': // RiemannTensor
-          Log() << Verbose(0) << "Old: " << config::RiemannTensor << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::RiemannTensor << "\t new: ");
           cin >> config::RiemannTensor;
           break;
         case 'n': // LevRFactor
-          Log() << Verbose(0) << "Old: " << config::LevRFactor << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::LevRFactor << "\t new: ");
           cin >> config::LevRFactor;
           break;
         case 'o': // RiemannLevel
-          Log() << Verbose(0) << "Old: " << config::RiemannLevel << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::RiemannLevel << "\t new: ");
           cin >> config::RiemannLevel;
           break;
         case 'p': // Lev0Factor
-          Log() << Verbose(0) << "Old: " << config::Lev0Factor << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::Lev0Factor << "\t new: ");
           cin >> config::Lev0Factor;
           break;
         case 'r': // RTActualUse
-          Log() << Verbose(0) << "Old: " << config::RTActualUse << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::RTActualUse << "\t new: ");
           cin >> config::RTActualUse;
           break;
         case 's': // PsiType
-          Log() << Verbose(0) << "Old: " << config::PsiType << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::PsiType << "\t new: ");
           cin >> config::PsiType;
           break;
         case 't': // MaxPsiDouble
-          Log() << Verbose(0) << "Old: " << config::MaxPsiDouble << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::MaxPsiDouble << "\t new: ");
           cin >> config::MaxPsiDouble;
           break;
         case 'u': // PsiMaxNoUp
-          Log() << Verbose(0) << "Old: " << config::PsiMaxNoUp << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::PsiMaxNoUp << "\t new: ");
           cin >> config::PsiMaxNoUp;
           break;
         case 'v': // PsiMaxNoDown
-          Log() << Verbose(0) << "Old: " << config::PsiMaxNoDown << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::PsiMaxNoDown << "\t new: ");
           cin >> config::PsiMaxNoDown;
           break;
         case 'w': // AddPsis
-          Log() << Verbose(0) << "Old: " << config::AddPsis << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::AddPsis << "\t new: ");
           cin >> config::AddPsis;
           break;
 
         case 'x': // RCut
-          Log() << Verbose(0) << "Old: " << config::RCut << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::RCut << "\t new: ");
           cin >> config::RCut;
           break;
         case 'y': // StructOpt
-          Log() << Verbose(0) << "Old: " << config::StructOpt << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::StructOpt << "\t new: ");
           cin >> config::StructOpt;
           break;
         case 'z': // IsAngstroem
-          Log() << Verbose(0) << "Old: " << config::IsAngstroem << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::IsAngstroem << "\t new: ");
           cin >> config::IsAngstroem;
           break;
         case 'i': // RelativeCoord
-          Log() << Verbose(0) << "Old: " << config::RelativeCoord << "\t new: ";
+          DoLog(0) && (Log() << Verbose(0) << "Old: " << config::RelativeCoord << "\t new: ");
           cin >> config::RelativeCoord;
           break;
@@ -646,5 +649,5 @@
   }
   strcpy(configname, ptr);
-  Log() << Verbose(0) << "Found configpath: " << configpath << ", dir slash was found at " << last << ", config name is " << configname << "." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Found configpath: " << configpath << ", dir slash was found at " << last << ", config name is " << configname << "." << endl);
   delete[](buffer);
 };
@@ -657,5 +660,5 @@
 {
   if (FileBuffer != NULL) {
-    eLog() << Verbose(2) << "deleting present FileBuffer in PrepareFileBuffer()." << endl;
+    DoeLog(2) && (eLog()<< Verbose(2) << "deleting present FileBuffer in PrepareFileBuffer()." << endl);
     delete(FileBuffer);
   }
@@ -674,5 +677,5 @@
 {
   int MaxTypes = 0;
-  element *elementhash[MAX_ELEMENTS];
+  const element *elementhash[MAX_ELEMENTS];
   char name[MAX_ELEMENTS];
   char keyword[MAX_ELEMENTS];
@@ -683,5 +686,5 @@
 
   if (mol == NULL) {
-    eLog() << Verbose(0) << "Molecule is not allocated in LoadMolecule(), exit.";
+    DoeLog(0) && (eLog()<< Verbose(0) << "Molecule is not allocated in LoadMolecule(), exit.");
     performCriticalExit();
   }
@@ -689,9 +692,9 @@
   ParseForParameter(verbose,FileBuffer,"MaxTypes", 0, 1, 1, int_type, &(MaxTypes), 1, critical);
   if (MaxTypes == 0) {
-    eLog() << Verbose(0) << "There are no atoms according to MaxTypes in this config file." << endl;
-    performCriticalExit();
+    DoeLog(1) && (eLog()<< Verbose(1) << "There are no atoms according to MaxTypes in this config file." << endl);
+    //performCriticalExit();
   } else {
     // prescan number of ions per type
-    Log() << Verbose(0) << "Prescanning ions per type: " << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Prescanning ions per type: " << endl);
     int NoAtoms = 0;
     for (int i=0; i < MaxTypes; i++) {
@@ -700,5 +703,5 @@
       ParseForParameter(verbose,FileBuffer, name, 0, 2, 1, int_type, &Z, 1, critical);
       elementhash[i] = periode->FindElement(Z);
-      Log() << Verbose(1) << i << ". Z = " << elementhash[i]->Z << " with " << No[i] << " ions." << endl;
+      DoLog(1) && (Log() << Verbose(1) << i << ". Z = " << elementhash[i]->Z << " with " << No[i] << " ions." << endl);
       NoAtoms += No[i];
     }
@@ -708,5 +711,5 @@
     sprintf(name,"Ion_Type%i",MaxTypes);
     if (!ParseForParameter(verbose,FileBuffer, (const char*)name, 1, 1, 1, int_type, &value[0], 1, critical)) {
-      eLog() << Verbose(0) << "There are no atoms in the config file!" << endl;
+      DoeLog(0) && (eLog()<< Verbose(0) << "There are no atoms in the config file!" << endl);
       performCriticalExit();
       return;
